{# _datamax/api/templates/validation/add_s3.html_ #}
{% extends "validation_layout.html" %}

{% block body %}
<div class="row">
    <div class="col-md-8">
        <h5 class="card-title">Add S3 file</h5>
    </div>
    <div class="col-md-4 text-right">

    </div>
</div>
<br/>
<form method="post" action="{{ url_for('api_exchange.index') }}" id="addS3Fileform">
    <input type="hidden" name="name" value="register_file_for_validation"/>
    <input type="hidden" name="source_type" value="s3"/>
    <input type="hidden" name="properties" id="properties"/>
    <input type="hidden" name="shape" id="shape" />

    <div class="form-group">
        <label for="project">Project</label>
        <select class="form-control" id="project" name="project">
            <option disabled selected value></option>
        </select>
        <small id="projectHelp" class="form-text text-muted">
        </small>
    </div>
    <div class="form-group">
        <label for="connector">Connector</label>
        <select class="form-control" id="connector" name="connector_id">
            <option disabled selected value></option>
        </select>
        <small id="connectorHelp" class="form-text text-muted">
            Connections will be established at run time for the given resource key.
        </small>
    </div>
    <div class="form-group">
        <label for="connector">Registration Name</label>
        <input type="text" class="form-control" id="file_name" placeholder="" name="file_name">
    </div>
    <div class="form-group">
        <label for="description">Description</label>
        <input type="text" class="form-control" id="description" placeholder="" name="description">
    </div>
    <div class="form-group">
        <label for="source_bucket">Source bucket</label>
        <input type="text" class="form-control" id="source_bucket" placeholder="" name="source_bucket">
    </div>
    <div class="form-group">
        <label for="source_object">Source object</label>
        <input type="text" class="form-control" id="source_object" placeholder="" name="source_object">
        <small id="objectHelp" class="form-text text-muted">
            Source object's path should end with slash /.
        </small>
    </div>
    <div class="form-group">
        <label for="header_object">Header object</label>
        <input type="text" class="form-control" id="header_object" placeholder="" name="header_object">
        <small id="headerHelp" class="form-text text-muted">
            Header file should be a complete file path along with file extension.
        </small>
    </div>
    <div class="form-group">
        <label>If data file mentioned in source object has header as first row.</label>
        <br>
        <div class="form-check form-check-inline">
            <input class="form-check-input" type="radio" name="data_header" id="inlineRadio1"
                   value="True">
            <label class="form-check-label" for="inlineRadio1">True</label>
        </div>
        <div class="form-check form-check-inline">
            <input class="form-check-input" type="radio" name="data_header" id="inlineRadio2"
                   value="False" checked>
            <label class="form-check-label" for="inlineRadio2">False</label>
        </div>
    </div>
    <div class="form-group">
        <label for="delimiter">Delimiter</label>
        <input type="text" class="form-control" id="delimiter" placeholder="" name="delimiter">
    </div>
    <div class="form-group">
        <label for="file_format">File format</label>
        <select class="form-control" id="file_format" name="file_format">
            <option value="TEXTFILE">TEXTFILE</option>
            <option value="PARQUET">PARQUET</option>
            <option value="ORC">ORC</option>
            <option value="AVRO">AVRO</option>
            <option value="SEQUENCEFILE">SEQUENCEFILE</option>
        </select>
    </div>
    <input type="submit" class="btn btn-primary float-right" name="submit" value="Add">
    <div class="loading float-right"></div>

</form>

<script>
    $("#addS3Fileform").submit(function() {
        // build properties
        $("#properties").val(JSON.stringify({
            "source_bucket" : $("input[name='source_bucket']").val(),
            "source_object" : $("input[name='source_object']").val(),
            "header_object" : $("input[name='header_object']").val(),
            "delimiter"     : $("input[name='delimiter']").val(),
            "data_header"   : $("input[name='data_header']").val(),
            "file_format"   : $("select[name='file_format']").val(),
        }));

        var shapeFormData = "s3_connector_id="+ $("#connector").val() + "&source_bucket=" + $("#source_bucket").val() + "&header_object=" + $("#header_object").val();
        var shape = [];

        $.get("{{ url_for('operations.read_header') }}?" + shapeFormData,  function (data) {
            console.log(data);
            $("#delimiter").val(data.delimiter);

            $.each(data.header, function(index, val){
                shape.push({"name": val, "dtype": "varchar"});
            });
            $("#shape").val(JSON.stringify(shape));

            // submit the form
            $.ajax({
                 type: "GET",
                 url: $("#addS3Fileform").attr('action'),
                 data: $("#addS3Fileform").serialize(),
                 success: function(data) {
                    console.log(data);
                    window.location.href = "{{ url_for('views_validation.index') }}";
                 }
               }); // .second request ends
       });
       return false;
    });

    $(document).ready(function(){
        // building project names drop-down menu
        $.ajax({
        type:"POST",
        url: "{{ url_for('api_exchange.index') }}?name=all_projects",
        data: {},
        success: function(data) {
            console.log(data);
            $.each(data.Contents, function(index, val){
                $("#project").append('<option value="' + val.id + '">' + val.name + '</option>');
            });
        }
        });

        $("#project").on( "change", function() {
            var project_id = $(this).val();
            $("#connector").html("<option disabled selected value></option>");
            $.ajax({
                type:"POST",
                url: "{{ url_for('api_exchange.index') }}?name=get_connections&connection_type=s3&project_id=" + project_id,
                data: {},
                success: function(data) {
                    console.log(data);
                    $.each(data.Contents, function(index, val){
                        $("#connector").append('<option value="' + val.id + '">' + val.name + '</option>');
                    });
                }
             });
        });
    });



</script>


{% endblock %}